<template>
  <el-dialog
    v-loading="loading"
    :title="title"
    :center="true"
    align="left"
    top="10vh"
    width="500px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="showModelThis = false"
  >
    <el-card style="margin-top: -20px">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :size="'mini'"
            :rules="rules"
            label-width="80px"
            class="demo-ruleForm"
          >
            <el-form-item label="手机号" prop="mobile">
              <el-input
                v-model="ruleForm.mobile"
                :placeholder="'手机号'"
                maxlength="11"
                :disabled="isDetail"
              />
            </el-form-item>

            <el-form-item label="验证码" prop="code" v-if="id === 'add'">
              <el-input
                v-model="ruleForm.code"
                :placeholder="'验证码'"
                maxlength="6"
                :disabled="isDetail"
              >
                <send-verification-code
                  slot="append"
                  :mobile="ruleForm.mobile"
                  @phoneErr="phoneErr"
                />
              </el-input>
            </el-form-item>
          </el-form>
        </el-col>
        <el-col :span="24" class="tr">
          <el-button v-if="!isDetail" type="primary" @click="submitForm" :size="'mini'"
            >保 存
          </el-button>
          <el-button @click="showModelThis = false" :size="'mini'">{{
            isDetail ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from "@/apis/service/operate/account";
import resToken from "@/mixins/resToken";
import {
  isnumber,
  isMobile,
  isAlphanumeric,
  isEmoticon,
  validAlphabets,
} from "@/utils/validate";

/**
 * @props
 *  nickname 账号名
 *  mobile 手机号
 *  level 角色等级
 */

export default {
  name: "Account",
  props: ["showModel", "id", "isDetail", "sitem"],
  mixins: [resToken],
  data() {
    const validatemobile = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("手机号不能为空！"));
      } else {
        if (!isMobile(value)) {
          callback(new Error("手机号格式不正确！"));
        } else {
          callback();
        }
      }
    };

    return {
      roleList: [],
      loading: false,
      title: "添加账号",
      organizeList: [],
      showModelThis: this.showModel,
      coptions: [],
      is_mainoptions: [],
      isIndeterminate: false,
      ruleForm: {
        mobile: "", //手机号
        code: "",
      },
      platformoptions: [],
      rules: {
        mobile: [
          {
            required: true,
            validator: validatemobile,
            trigger: "blur",
          },
        ],
        code: [
          {
            required: true,
            trigger: "blur",
            message: "角色等级",
          },
        ],
      },
    };
  },
  watch: {
    showModel: function (val) {
      this.showModelThis = val;
      if (val) {
        this.initForm();
        console.log(this.ruleForm);
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit("cancel");
      }
    },
  },
  mounted() {},
  methods: {
  
    phoneErr(e) {
      if (!e) {
        this.$refs.ruleForm.validateField("mobile");
      }
    },
    async initForm() {
      this.loading = true;

      await this.resetForm();

      if (this.id === "add") {
        this.title = "添加账号";
        this.rulesThis = this.rules;
      } else {
        if (this.isDetail) {
          this.title = "账号详情";
          this.rulesThis = {};
        } else {
          this.title = "修改账号";
          this.rulesThis = this.rules;
        }
      }
      this.loading = false;
    },

    async getClist() {
      this.organizeList = [];
      const { code, data, message } = await asyncRequest.getClist({
        size: 10000,
      });
      if (code === 1) {
        this.organizeList = data;
        this.recursion(this.organizeList);
      }
    },
    handleCheckedCitiesChange(value) {
      console.log(value);
      let checkedCount = value.length;
      this.ruleForm.is_all = checkedCount === this.coptions.length;
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.coptions.length;
    },
    recursion(list) {
      list.map((v) => {
        if (v && Array.isArray(v.child)) {
          v.value = v.id + "";
          v.label = v.name;
          if (v.child.length === 0) {
            delete v["child"];
          } else {
            this.recursion(v.child);
          }
        }
        return v;
      });
    },
    async getRole() {
      const model = {
        status: "", // 状态
        level: "", // 姓名
        role_name: "",
      };
      const res = await asyncRequest.getRole(model);
      if (res && res.code === 0 && res.data) {
        this.roleList = res.data;
        this.roleList.map((v1) => {
          v1.id += "";
          v1.status += "";
          return v1;
        });
      }
    },
    async initData() {
      const { code, data } = await asyncRequest.detail({
        id: this.id,
      });
      if (code === 1) {
        await this.resetForm(data);
      }
    },
    async resetForm() {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields();
          this.$refs.ruleForm.clearValidate();
          if (this.sitem) {
            const { email, password, username, nickname, mobile, id } = this.sitem;

            this.ruleForm = {
              id,
              email: email || "",
              password: password || "",
              username: username || "",
              nickname: nickname || "",
              mobile: mobile || "",
              code: "",
            };
          } else {
            this.ruleForm = {
              email: "",
              password: "",
              username: "",
              nickname: "", // 账号名
              mobile: "",
              code: "",
            };
          }
        }
      });
    },
    async submitForm() {
      await this.$refs.ruleForm.validate(async (valid) => {
        if (valid) {
          if (!this.loading) {
            this.loading = true;
            const { username, nickname, password, mobile, email, id,code } = JSON.parse(
              JSON.stringify(this.ruleForm)
            );

            const model = {
              password,
              nickname,
              username,
              mobile,
              email,
              id,
              code
            };

            let res = {};
            if (this.id === "add") {
              delete model["id"];
              res = await asyncRequest.register(model);
            } else {
              res = await asyncRequest.update(model);
            }
            this.loading = false;
            if (res && res.code === 1) {
              const title = this.id === "add" ? "添加成功" : "修改成功";
              this.$notify.success({
                title,
                message: "",
              });
              this.showModelThis = false;
              // 刷新
              this.$emit("refresh");
            }
          }
        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.account {
}
</style>
